diff --git a/gutils/giofile.c b/gutils/giofile.c
index 695f283ba3..5696bbef3e 100644
--- a/gutils/giofile.c
+++ b/gutils/giofile.c
@@ -162,7 +162,7 @@ static GDirEntry* _gio_create_dirent(const char *path, const char *name) {
 static void _gio_file_dir(GIOControl *gc, char *path) {
     GDirEntry *head=NULL, *last=NULL, *cur;
     GDir *dir = NULL;
-    GError *error;
+    GError *error = NULL;
     const gchar *ent_name;
     
     dir = g_dir_open(path, 0, &error);
@@ -201,6 +201,7 @@ static void _gio_file_dir(GIOControl *gc, char *path) {
     }
 #endif
     
+    g_error_free(error);
     g_dir_close(dir);
     
     gc->iodata = head;
